
-- declaring local variables that will be used only inside map-functions.lua
local tileW, tileH, tileset, quads, tileTable

quadInfo = {
  { '.', 0, 0 }, -- floor outside
  { ' ', 120, 180 }, --10,15 -> 120,180 DONE floor inside
  { '#', 12, 132 }, --1,11 -> 12,132 DONE wall
  { '<', 144, 36 }, -- 12,3 -> 144,36 staircase
  { '$', 48, 24 }, -- 4,2 coin money
  { '^', 60,0 }, -- test , 
  { '>', 168,36 }, --corner right side bottom 18/11
  { '+', 132,24 }, -- closed door 11,2 -> 121, 24
  { '/', 180,24}, --open dor 15,2 -> 180,24
  { '@', 0,48 },
  { '!', 12,24 } --potion on 1,2 => 12,24
}

--newMap(12,12,'Alloy_curses_12x12.png',tileString,quadInfo)



--function loadMap(path)
  --love.filesystem.load(path)() -- attention! extra parenthesis
function loadMap()

  	maps = {'mapstring.lua','mapstring2.lua'}

	math.randomseed( os.time() )
	math.random(); math.random(); math.random()

	testnumber = math.random(2)

	selectedmap = maps[testnumber]

	--if selectedmap = 

	love.filesystem.load(selectedmap)()
	
	maps[testnumber] = nil

	--loadMap(maps)
end

function newMap(tileWidth, tileHeight, tilesetPath, tileString, quadInfo)
  
  tileW = tileWidth
  tileH = tileHeight
  tileset = love.graphics.newImage(tilesetPath)

  map = {}

  map.time = 30
  
  local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
  
  quads = {}
  
  for _,info in ipairs(quadInfo) do
    -- info[1] = the character, info[2] = x, info[3] = y
    quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW, tileH, tilesetW, tilesetH)
  end
  
  tileTable = {}
  
  local width = #(tileString:match("[^\n]+"))

  for x = 1,width,1 do tileTable[x] = {} end

  local rowIndex,columnIndex = 1,1
  for row in tileString:gmatch("[^\n]+") do
    assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    columnIndex = 1
    for character in row:gmatch(".") do
      tileTable[columnIndex][rowIndex] = character

      -- add random items
	
	if tileTable[columnIndex][rowIndex] == " " and love.math.random(150) == 20 then
		--love.graphics.setColor(255,255,255)
		tileTable[columnIndex][rowIndex] = '$'
	end

	if tileTable[columnIndex][rowIndex] == ' ' and love.math.random(1000) == 10 then

		tileTable[columnIndex][rowIndex] = "!"
	end

	--if tileTable[columnIndex][rowIndex] == ' ' and love.math.random


	columnIndex = columnIndex + 1
	
	
      --love.graphics.setColor(255,255,255)
      --love.graphics.print(character,100,100)

    end
    rowIndex=rowIndex+1
  end

end

function checkEnemy(columnIndex,rowIndex)
	if tileTable[columnIndex][rowIndex] ~= ' ' then
		return true
	end

	return false
end

function checkitems(dx,dy)

	if tileTable[playertilex+dx][playertiley+dy] == '$' then
		playertest.money = playertest.money + 1
		output.addMessage("You picked up a coin!")
		tileTable[playertilex][playertiley] = ' '
	end

	if tileTable[playertilex+dx][playertiley+dy] == "^" then
		playertest.health = 0
	end

	if tileTable[playertilex+dx][playertiley+dy] == '+' then
		tileTable[playertilex][playertiley] = '/'
	end
	
end

function changemap(dx,dy)

	if tileTable[playertilex+dx][playertiley+dy] == '<' then

		playertilex = 17
		playertiley = 15
		playertest.dungeonlevel = playertest.dungeonlevel + 1
		loadMap()
		return
	end
end
		

function drawMap()
	--love.graphics.setColor(255,255,255)
	-- transparency variable = >
	t = (map.time/30)*255
	love.graphics.setColor(255,255,255,t)
	--a= math.random(255)
	--b=math.random(255)
	--c=math.random(255)
  	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0

		if tileTable[columnIndex][rowIndex] == '$' then
			love.graphics.setColor(218,165,32,t)
		end
		if tileTable[columnIndex][rowIndex] == "^" then
			love.graphics.setColor(48,48,211,t)
		end
      		love.graphics.draw(tileset, quads[ char ] , x, y)
		love.graphics.setColor(255,255,255,t)

      		--[[if tileTable[columnIndex][rowIndex] == '.' then
	     	 	love.graphics.print("FUCK YOU",x,y)
		end]] -- TEST CONCEPT WORKS

		--[[if tileTable[columnIndex][rowIndex] == "." and love.math.random(10) == 10 then
			love.graphics.setColor(255,0,0)
			love.graphics.rectangle("fill",12*(columnIndex-1)+200,12*(rowIndex-1),12,12)
		end]]
   	 end
  	end
end

--[[function mapcheck()
	--local x = 1
	--local y = 1
	--
	test:coordinate(x,y)
	
	for columnIndex,column in ipairs(tileTable) do
		for rowIndex,char in ipairs(column) do

			if tileTable[self.x][self.y] == '#' then
				return false
			end
			return true
		end
	end

end]]


--[[function mapcheck(x,y)

	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		--local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0
      		--love.graphics.draw(tileset, quads[ char ] , x, y)
		--

			
			
		
			if tileTable[0][0] == '#' then
				return false
			else 
				return true
			end

      		--if tileTable[columnIndex][rowIndex] == '.' then
	     	 	love.graphics.print("FUCK YOU",x,y)
		end -- TEST CONCEPT WORKS
   	 	end
  	end



end]]

function playercheck(dx,dy)

	--TILETABLE[Y][X] FK ME

	--local dx,dy = 0,0
	--playertile = 791

	
	love.graphics.setColor(0,255,0)
	--love.graphics.print("$",(playertiley)*12,(playertilex)*12+200)

	if tileTable[playertilex][playertiley-1] == '#' then --UP
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.rectangle("fill",(playertilex-1)*12+200,(playertiley-2)*12,12,12)
	end
	if tileTable[playertilex][playertiley+1] == '#' then --DOWN
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-1)*12+200,playertiley*12,12,12)
	end

	if tileTable[playertilex+1][playertiley] == '#' then --RIGHT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",playertilex*12+200,12*(playertiley-1),12,12)
	end

	if tileTable[playertilex-1][playertiley] == '#' then --LEFT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-2)*12+200,(playertiley-1)*12,12,12)
	end

	if tileTable[playertilex+dx][playertiley+dy] == '#' then
		return false
	end
	 
	return true

	--if tileTable[playertilex+dx][playertiley+dy] == '#'  then
		--return false
	
	--[[if tileTable[playertilex+dy][playertiley+dy] == '+' then
		return false
	end

	return true]]

	--return true

end

function doorcheck(dx,dy)

	doorbreak = 0

	--[[if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) == 3 then
		output.addMessage("You opened a door!")
		return true
	elseif tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) ~= 3 then
		output.addMessage("The door is locked. Kick it in!")
		return false
	end

	if tileTable[playertilex + dx][playertiley + dy] ~= '+' then
		return true
	end]]

	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(5) == 3 then
		output.addMessage("You opened a door!")
		return true
	end
	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(5) ~= 3 then
		doorbreak = 0
		if doorbreak == 0 then
			output.addMessage("The door is locked. Kick it in!")
			doorbreak = doorbreak + 1
		elseif doorbreak ~= 0 then
			output.addMessage("KABOOM!")
		end
		return false
	end
	
	if tileTable[playertilex+dx][playertiley+dy] ~= '+' then
		return true

	end


end

--[[function additems()

	if tileTable[columnIndex][rowIndex] == "." and love.math.random(10) == 10 then
		tileTable[columnIndex][rowIndex] = "*"
	end

end]]

